#include "nexnooper.h"

UCHAR g_ucLowerCase[256];

void InitLowerCaseMap()
{
 UINT i;
 for (i = 0; i < 256; i++) g_ucLowerCase[i] = i;
 for (i = (UCHAR)'A'; i <= (UCHAR)'Z'; i++) g_ucLowerCase[i] = i + 32;
 for (i = (UCHAR)''; i <= (UCHAR)''; i++) g_ucLowerCase[i] = i + 32;
 g_ucLowerCase[(UCHAR)''] = '';
}

#define to_lower(c) g_ucLowerCase[(UCHAR)(c)]

PCSTR _stristr(PCSTR pcsStr1, PCSTR pcsStr2)
{
 if (!*pcsStr2)
  return pcsStr1;
 for (; *pcsStr1; ++pcsStr1)
  if (to_lower(*pcsStr1) == to_lower(*pcsStr2))
  {
   PCSTR p1, p2;
   for (p1 = pcsStr1, p2 = pcsStr2; *p1 && *p2; ++p1, ++p2)
    if (to_lower(*p1) != to_lower(*p2)) break;
   if (!*p2)
    return pcsStr1;
  }
 return NULL;
}


UCHAR g_ucCyr[256];

void InitWACyrillicMap()
{
 UINT i;

 for (i = 0; i < 256; i++) g_ucCyr[i] = i;

 g_ucCyr[0x97] = ''; g_ucCyr[0x98] = ''; g_ucCyr[0x99] = ''; g_ucCyr[0x9A] = ''; g_ucCyr[0xEB] = ''; g_ucCyr[0x9B] = '';
 g_ucCyr[0x9C] = ''; g_ucCyr[0x9D] = ''; g_ucCyr[0x9E] = ''; g_ucCyr[0xA2] = ''; g_ucCyr[0xA5] = ''; g_ucCyr[0xA6] = '';
 g_ucCyr[0xA7] = ''; g_ucCyr[0xA8] = ''; g_ucCyr[0xA9] = ''; g_ucCyr[0xAA] = ''; g_ucCyr[0xAB] = ''; g_ucCyr[0xAC] = '';
 g_ucCyr[0xAD] = ''; g_ucCyr[0xAE] = ''; g_ucCyr[0xB1] = ''; g_ucCyr[0xB0] = ''; g_ucCyr[0xAF] = ''; g_ucCyr[0xB2] = '';
 g_ucCyr[0xB3] = ''; g_ucCyr[0xB4] = '';

 g_ucCyr[0x80] = ''; g_ucCyr[0x81] = ''; g_ucCyr[0x82] = ''; g_ucCyr[0xCB] = ''; g_ucCyr[0x83] = ''; g_ucCyr[0x84] = '';
 g_ucCyr[0x85] = ''; g_ucCyr[0x86] = ''; g_ucCyr[0x87] = ''; g_ucCyr[0x88] = ''; g_ucCyr[0x89] = ''; g_ucCyr[0x8A] = '';
 g_ucCyr[0x8B] = ''; g_ucCyr[0x8C] = ''; g_ucCyr[0x8D] = ''; g_ucCyr[0x8E] = ''; g_ucCyr[0x8F] = ''; g_ucCyr[0x92] = '';
 g_ucCyr[0x91] = ''; g_ucCyr[0x90] = ''; g_ucCyr[0x93] = ''; g_ucCyr[0x94] = ''; g_ucCyr[0x96] = '';
}


int _atoi(PCSTR pcsStr)
{
 int n = 0;
 while (*pcsStr)
 {
  n = (n << 3) + (n << 1) + (*pcsStr - '0');
  pcsStr++;
 }
 return n;
}


#ifndef _DEBUG
HANDLE g_hProcessHeap;

PVOID malloc(UINT nSize)
{
 return HeapAlloc(g_hProcessHeap, 0, nSize);
}

void free(PVOID pBuf)
{
 HeapFree(g_hProcessHeap, 0, pBuf);
}

PVOID memset(PVOID s, int c, UINT n)
{
 PUCHAR us = s;
 while (n--) *us++ = (UCHAR)c;
 return s;
}

PVOID memcpy(PVOID pDst, const PVOID pSrc, UINT nCnt)
{
 PUCHAR pucDst = pDst;
 const unsigned char * pucSrc = pSrc;
 while (nCnt--)
  *pucDst++ = *pucSrc++;
 return pDst;
}

int memcmp(const void * s1, const void * s2, size_t n)
{
 const unsigned char *p1 = s1, *p2 = s2;
 while (n--) if (*p1 != *p2) return *p1 - *p2; else *p1++, *p2++;
 return 0;
}

UINT strlen(PCSTR pcsStr)
{
 PCSTR p1;
 for (p1 = pcsStr; *p1; ++p1);
 return (p1 - pcsStr);
}

PSTR strstr(PCSTR pcsStr1, PCSTR pcsStr2)
{
 UINT nLen = strlen(pcsStr2);
 while (*pcsStr1)
  if (!memcmp(pcsStr1++, pcsStr2, nLen))
   return (PSTR)pcsStr1 - 1;
 return NULL;
}

PSTR strcpy(PSTR psDst, PCSTR pcsSrc)
{
 PSTR psSave = psDst;
 while (*psDst++ = *pcsSrc++);
 return psSave;
}

int strcmp(PCSTR pcsStr1, PCSTR pcsStr2)
{
 for(; *pcsStr1 == *pcsStr2; ++pcsStr1, ++pcsStr2)
  if (*pcsStr1 == 0) return 0;
 return *(const unsigned char *)pcsStr1 - *(const unsigned char *)pcsStr2;
}

PSTR strchr(PCSTR pcsStr, int nChar)
{
 while (*pcsStr != (char)nChar)
  if (!*pcsStr++) return NULL;
 return (PSTR)pcsStr;
}
#endif
